<?php
/**
 * @version 	$Id: docmanrss.php 23 2009-06-04 02:32:46Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ();

class DocmanrssControllerDocmanrss extends DocmanrssController {

	function __construct() {

		parent::__construct ();
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
	}

	function edit() {

		JRequest::setVar ( 'view', 'feed' );
		//		JRequest::setVar ( 'layout', 'form' );
		JRequest::setVar ( 'hidemainmenu', 1 );
		parent::display ();
	}

	function save() {

		$task = JRequest::getVar ( 'task' );
		
		$model = $this->getModel ( 'feed' );
		
		if ($returnid = $model->store ( $post )) {
			
			switch ($task) {
				case 'apply' :
					$link = 'index.php?option=com_docmanrss&controller=docmanrss&task=edit&cid[]=' . $returnid;
					break;
				
				default :
					$link = 'index.php?option=com_docmanrss';
					break;
			}
			
			$msg = JText::_ ( 'Feed Saved!' );
		}
		else {
			$msg = JText::_ ( 'Error Saving Feed' );
		}
		
		$this->setRedirect ( $link, $msg );
	}

	function remove() {

		$model = $this->getModel ( 'feed' );
		if (! $model->delete ()) {
			$msg = JText::_ ( 'Error: One or more Feedss could not be Deleted' );
		}
		else {
			$msg = JText::_ ( 'Feed(s) Deleted' );
		}
		$this->setRedirect ( 'index.php?option=com_docmanrss', $msg );
	}

	function publish() {

		$cid = JRequest::getVar ( 'cid', array (), 'post', 'array' );
		
		if (! is_array ( $cid ) || count ( $cid ) < 1) {
			JError::raiseError ( 500, JText::_ ( 'Select an item to publish' ) );
		}
		
		$model = $this->getModel ();
		
		if (! $model->publish ( $cid, 1 )) {
			echo "<script> alert('" . $model->getError () . "'); window.history.go(-1); </script>\n";
		}
		
		$total = count ( $cid );
		
		$msg = JText::sprintf ( 'ITEMS PUBLISHED', $total );
		
		$this->setRedirect ( 'index.php?option=com_docmanrss', $msg );
	}

	function unpublish() {

		$cid = JRequest::getVar ( 'cid', array (), 'post', 'array' );
		
		if (! is_array ( $cid ) || count ( $cid ) < 1) {
			JError::raiseError ( 500, JText::_ ( 'Select an item to unpublish' ) );
		}
		
		$model = $this->getModel ();
		
		if (! $model->publish ( $cid, 0 )) {
			echo "<script> alert('" . $model->getError () . "'); window.history.go(-1); </script>\n";
		}
		
		$total = count ( $cid );
		
		$msg = JText::sprintf ( 'ITEMS UNPUBLISHED', $total );
		
		$this->setRedirect ( 'index.php?option=com_docmanrss', $msg );
	}

	function cancel() {

		$msg = JText::_ ( 'Operation Cancelled' );
		$this->setRedirect ( 'index.php?option=com_docmanrss', $msg );
	}
}
?>