<?php
/**
 * @version 	$Id: feed.php 57 2009-06-12 00:46:45Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ();
jimport ( 'joomla.application.component.model' );

class DocmanrssModelFeed extends JModel {

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}
	
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			
			$query = ' SELECT * FROM #__docmanrss '.
					'  WHERE id = '.$this->_id;
			
			$this->_db->setQuery( $query );
			
			$this->_data = $this->_db->loadObject();
						
			$this->_data->catids =  explode(',',$this->_data->catids);
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->name = '';
			$this->_data->params = '';
			$this->_data->changed = null;
			$this->_data->catids = '';
			$this->_data->published = null;
		}
		return $this->_data;
	}
	
	function store()
	{	
		$row = $this->getTable('docmanrss');

		$data = JRequest::get( 'post' );

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the hello record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}

		return $row->id;
	}
	
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable('docmanrss');

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}						
		}
		return true;
	}
	
	function getDocCategories(){
		
		$query = "SELECT c.*, c.parent_id AS parent"
		. "\n FROM #__categories c"
		. "\n WHERE section='com_docman'"
		. "\n AND published != -2"
		. "\n ORDER BY ordering" ;
		
	
		$database= JFactory::getDBO();
		
		$database->setQuery($query);
		
		$objects = $database->loadObjectList();
		
		return $objects;
	}
	
}
?>