<?php
/**
 * @version 	$Id: view.html.php 64 2009-06-13 19:17:50Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ();
jimport ( 'joomla.application.component.view' );

class DocmanrssViewFeed extends JView {

	function display($tpl = null) {
		$document	= & JFactory::getDocument();		
		$document->addStyleSheet('components/com_docmanrss/assets/css/docmanrssbackend.css');

		JLoader::register ( 'JHTMLSelect', JPATH_LIBRARIES . DS . 'joomla' . DS . 'html' . DS . 'html' . DS . 'select.php' );

		$doccats = $this->get ( 'DocCategories' );
		$feed = $this->get ( 'Data' );
		
		$paramsdata = $feed->params;
		$paramsdefs = JPATH_COMPONENT . DS . 'models' . DS . 'feed.xml';
		$params = new JParameter ( $paramsdata, $paramsdefs );
		
		// establish the hierarchy of the menu
		$children = array ();
		
		// first pass - collect children
		foreach ( $doccats as $v ) {
			$pt = $v->parent;
			
			if (isset ( $children [$pt] )) {
				$list = $children [$pt];
			}
			else {
				$list = array ();
			}
			
			array_push ( $list, $v );
			$children [$pt] = $list;
		}
		
		$listelements = JHTML::_ ( 'menu.treerecurse', 0, '', array (), $children );
		$docselectlist = JHTML::_ ( 'select.genericlist', $listelements, 'catids[]', 'multiple="multiple" size="40"', 'id', 'treename', $feed->catids );
		
		$isNew = ($feed->id < 1);
		$text = $isNew ? JText::_ ( 'New' ) : JText::_ ( 'Edit' );
		
		JToolBarHelper::title ( JText::_ ( 'DOCman RSS <small>[' . $text . ']</small>' ), 'rss' );
		
		JToolBarHelper::save ();
		
		JToolBarHelper::apply ();
		
		if ($isNew) {
			JToolBarHelper::cancel ();
		}
		else {
			JToolBarHelper::cancel ( 'cancel', 'Close' );
		}
		
		$this->assignRef ( 'params', $params );
		$this->assignRef ( 'feed', $feed );
		$this->assignRef ( 'docselectlist', $docselectlist );
		
		parent::display ( $tpl );
	}
}