<?php
/**
 * @version 	$Id: install.php 74 2009-06-14 00:28:25Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @copyright	2003-2009 Think Network GmbH, Munich
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

$status = new JObject ( );
$status->plugins = array ();

$plugins = &$this->manifest->getElementByPath ( 'plugins' );
if (is_a ( $plugins, 'JSimpleXMLElement' ) && count ( $plugins->children () )) {
	
	foreach ( $plugins->children () as $plugin ) {
		$pname = $plugin->attributes ( 'plugin' );
		$pgroup = $plugin->attributes ( 'group' );
		$porder = $plugin->attributes ( 'order' );
		
		// Set the installation path
		if (! empty ( $pname ) && ! empty ( $pgroup )) {
			$this->parent->setPath ( 'extension_root', JPATH_ROOT . DS . 'plugins' . DS . $pgroup );
		}
		else {
			$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Install' ) . ': ' . JText::_ ( 'No plugin file specified' ) );
			return false;
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		
		// If the plugin directory does not exist, lets create it
		$created = false;
		if (! file_exists ( $this->parent->getPath ( 'extension_root' ) )) {
			if (! $created = JFolder::create ( $this->parent->getPath ( 'extension_root' ) )) {
				$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Install' ) . ': ' . JText::_ ( 'Failed to create directory' ) . ': "' . $this->parent->getPath ( 'extension_root' ) . '"' );
				return false;
			}
		}
		
		/*
		* If we created the plugin directory and will want to remove it if we
		* have to roll back the installation, lets add it to the installation
		* step stack
		*/
		if ($created) {
			$this->parent->pushStep ( array ('type' => 'folder', 'path' => $this->parent->getPath ( 'extension_root' ) ) );
		}
		
		// Copy all necessary files
		$element = &$plugin->getElementByPath ( 'files' );
		if ($this->parent->parseFiles ( $element, - 1 ) === false) {
			// Install failed, roll back changes
			$this->parent->abort ();
			return false;
		}
		
		// Copy all necessary files
		$element = &$plugin->getElementByPath ( 'languages' );
		if ($this->parent->parseLanguages ( $element, 1 ) === false) {
			// Install failed, roll back changes
			$this->parent->abort ();
			return false;
		}
		
		// Copy media files
		$element = &$plugin->getElementByPath ( 'media' );
		if ($this->parent->parseMedia ( $element, 1 ) === false) {
			// Install failed, roll back changes
			$this->parent->abort ();
			return false;
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO ();
		
		// Check to see if a plugin by the same name is already installed
		$query = 'SELECT `id`' . ' FROM `#__plugins`' . ' WHERE folder = ' . $db->Quote ( $pgroup ) . ' AND element = ' . $db->Quote ( $pname );
		$db->setQuery ( $query );
		if (! $db->Query ()) {
			// Install failed, roll back changes
			$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Install' ) . ': ' . $db->stderr ( true ) );
			return false;
		}
		$id = $db->loadResult ();
		
		// Was there a plugin already installed with the same name?
		if ($id) {
			
			if (! $this->parent->getOverwrite ()) {
				// Install failed, roll back changes
				$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Install' ) . ': ' . JText::_ ( 'Plugin' ) . ' "' . $pname . '" ' . JText::_ ( 'already exists!' ) );
				return false;
			}
		
		}
		else {
			$row = & JTable::getInstance ( 'plugin' );
			$row->name = JText::_ ( ucfirst ( $pgroup ) ) . ' - ' . JText::_ ( ucfirst ( $pname ) );
			$row->ordering = $porder;
			$row->folder = $pgroup;
			$row->iscore = 0;
			$row->access = 0;
			$row->client_id = 0;
			$row->element = $pname;
			$row->published = 0;
			$row->params = '';
			
			if (! $row->store ()) {
				// Install failed, roll back changes
				$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Install' ) . ': ' . $db->stderr ( true ) );
				return false;
			}
		}
		
		$status->plugins [] = array ('name' => $pname, 'group' => $pgroup );
	}
}

echo "Thank you for using DOCman RSS";

?>