<?php
/**
 * @version 	$Id: uninstall.php 72 2009-06-13 23:29:48Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @copyright	2005-2008 New Life in IT Pty Ltd.  All rights reserved.
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.application.helper' );

//$nPaths = $this->_paths;
$status = new JObject ( );
$status->modules = array ();
$status->plugins = array ();

$plugins = &$this->manifest->getElementByPath ( 'plugins' );
if (is_a ( $plugins, 'JSimpleXMLElement' ) && count ( $plugins->children () )) {
	
	foreach ( $plugins->children () as $plugin ) {
		$pname = $plugin->attributes ( 'plugin' );
		$pgroup = $plugin->attributes ( 'group' );
		
		// Set the installation path
		if (! empty ( $pname ) && ! empty ( $pgroup )) {
			$this->parent->setPath ( 'extension_root', JPATH_ROOT . DS . 'plugins' . DS . $pgroup );
		}
		else {
			$this->parent->abort ( JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Uninstall' ) . ': ' . JText::_ ( 'No plugin file specified' ) );
			return false;
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO ();
		
		// Delete the plugins in the #__plugins table
		$query = 'DELETE FROM #__plugins WHERE element = ' . $db->Quote ( $pname ) . ' AND folder = ' . $db->Quote ( $pgroup );
		$db->setQuery ( $query );
		if (! $db->query ()) {
			JError::raiseWarning ( 100, JText::_ ( 'Plugin' ) . ' ' . JText::_ ( 'Uninstall' ) . ': ' . $db->stderr ( true ) );
			$retval = false;
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		
		// Remove all necessary files
		$element = &$plugin->getElementByPath ( 'files' );
		if (is_a ( $element, 'JSimpleXMLElement' ) && count ( $element->children () )) {
			$this->parent->removeFiles ( $element, - 1 );
		}
		
		$element = &$plugin->getElementByPath ( 'languages' );
		if (is_a ( $element, 'JSimpleXMLElement' ) && count ( $element->children () )) {
			$this->parent->removeFiles ( $element, 1 );
		}
		
		// If the folder is empty, let's delete it
		$files = JFolder::files ( $this->parent->getPath ( 'extension_root' ) );
		if (! count ( $files )) {
			JFolder::delete ( $this->parent->getPath ( 'extension_root' ) );
		}
		
		$status->plugins [] = array ('name' => $pname, 'group' => $pgroup );
	}
}

echo "<strong>Joomla! DOCman RSS 0.5 Beta uninstalled</strong>";

?>