<?php
/**
 * @version 	$Id: dynfeed.php 74 2009-06-14 00:28:25Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ();
jimport ( 'joomla.application.component.model' );

class DocmanrssModelDynfeed extends JModel {

	var $_data = null;

	var $_feeditems = null;

	function __construct() {

		parent::__construct ();
		
		$id = JRequest::getInt ( 'catid', 0 );
		$this->setCatid ( $id );
	}

	function setCatid($catid) {

		$this->_catid = $catid;
		$this->_data = null;
	}

	function getCatid() {

		return $this->_catid;
	}

	function getData() {

		// Load the data
		if (empty ( $this->_data )) {
			
			$wheres [] = 'published = 1';
			$wheres [] = 'element = "docmanrssdyn"';
			$wheres [] = 'folder = "system"';
			
			$query = ' SELECT * FROM #__plugins ' . ' WHERE ' . implode ( "\n  AND ", $wheres );
			
			$this->_db->setQuery ( $query );
			
			$this->_data = $this->_db->loadObject ();
			$this->_data->params = new JParameter ( $this->_data->params );
		}
		if (! $this->_data) {
			$this->_data = new stdClass ( );
			$this->_data->id = null;
			$this->_data->name = '';
			$this->_data->params = '';
			$this->_data->changed = null;
			$this->_data->catids = '';
			$this->_data->published = null;
		}
		
		if (! $this->_data->published) {
			JError::raiseError ( 404, JText::_ ( "Feed not published" ) );
		}
		
		return $this->_data;
	}

	function getCategories() {

		if (empty ( $this->_categories )) {
			
			$query = "SELECT c.*, c.parent_id AS parent" . "\n FROM #__categories c" . "\n WHERE section='com_docman'" . "\n AND published != -2" . "\n ORDER BY ordering";
			
			$this->_db->setQuery ( $query );
			
			$this->_categories = $this->_db->loadObjectList ();
		}
		
		return $this->_categories;
	}

	function loadChild($catid) {

		$query = 'SELECT id 
		FROM #__categories
		WHERE section = "com_docman"
		AND published = 1
		AND parent_id =' . $catid;
		
		$this->_db->setQuery ( $query );
		
		$returnobject = $this->_db->loadObjectList ();
		
		return $returnobject;
	}

	function getItemid() {

		if (empty ( $this->_itemid )) {
			
			$query = "SELECT id FROM #__menu" . "\n WHERE link LIKE '%option=com_docman%'" . "\n AND type = 'component'" . "\n AND published = 1";
			
			$this->_db->setQuery ( $query, 0, 1 );
			
			$this->_itemid = $this->_db->loadResult ();
		}
		
		return $this->_itemid;
	}

	function getFeeditems() {

		if (empty ( $this->_data )) {
			$this->getData ();
		}
		
		if (! empty ( $this->_data->id )) {
			
			$this->_feeditems->params = $this->_data->params ;
			
			if (is_array ( $this->_catid )) {
				$catids = implode ( ',', $this->_catid );
			}
			else {
				$catids = $this->_catid;
			}


			
			if (! empty ( $catids )) {
				
				switch (strtolower ( $this->_feeditems->params->get ( 'orderby', 'rdate' ) )) {
					case 'date' :
						$orderby = 'ASC';
						break;
					
					case 'rdate' :
						$orderby = 'DESC';
						break;
					
					default :
						$orderby = 'DESC';
						break;
				}
				
				$select = 'docman.id AS item, docman.catid, docman.dmname, docman.dmfilename, docman.dmsubmitedby, docman.dmthumbnail, docman.dmdescription, docman.access, categories.id,UNIX_TIMESTAMP( docman.dmdate_published ) AS created_ts, categories.published';
				$from [] = '#__docman AS docman';
				$from [] = 'INNER JOIN #__categories AS categories';
				$from [] = 'ON docman.catid = categories.id';
				
				$wheres [] = 'docman.published=1';
				$wheres [] = 'categories.published=1';
				$wheres [] = 'docman.catid in (' . $catids . ')';
				$wheres [] = 'docman.access=0';
				
				$orderbys = 'docman.dmdate_published ' . $orderby;
				
				$limits = $this->_feeditems->params->get ( 'count', 0 );
				
				$query = "SELECT " . $select . "\n FROM " . implode ( "\n ", $from ) . "\n WHERE " . implode ( "\n  AND ", $wheres ) . "\n ORDER BY " . $orderbys . "\n LIMIT " . $limits;
				
				$this->_db->setQuery ( $query );
				
				$this->_feeditems->items = $this->_db->loadObjectList ();
			}
			else {
				$this->_feeditems->items = array ();
			}
		}
		
		return $this->_feeditems;
	}

}
?>
