<?php
/**
 * @version 	$Id: view.feed.php 74 2009-06-14 00:28:25Z gammla $
 * @package 	Joomla
 * @subpackage 	DOCman RSS
 * @copyright 	(C) 2005 - 2009 Stephan Titz
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * DOCman RSS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * EventList is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.application.component.view' );
jimport ( 'joomla.filesystem.file' );

class DocmanrssViewDynfeed extends JView {

	function display() {

		$config = JFactory::getConfig ();
		$offset = $config->getValue ( 'offset', 0 );
		($offset < 0) ? $offset = "+" . sprintf ( "%02d", $offset ) . ":00" : $offset = "+" . sprintf ( "%02d", $offset ) . ":00";
		
		define ( "TIME_ZONE", $offset );
		
		$docmanconfig = new dmConfig ( );
		
		// Get the DOCman Itemid
		$itemid = $this->get ( 'Itemid' );
		
		// Get some Data from the model
		$data = $this->get ( 'Data' );
		$params = $data->params;
		
		$catid = $this->get ( 'Catid' );
		
		
		$catids = $this->getChilds ( $catid );
		$catids = $this->getCatidstoarray($catids);
		$catids[] = $catid;
		
		$model = $this->getModel ();
		$model->setCatid($catids);
		
		// Get some feeditems from the model
		$feeditems = $this->get ( 'Feeditems' );
		
		// Get categories
		$categories = $this->get ( 'Categories' );
		
		
		$rows = $feeditems->items;
		
		$pathtothumb = '/images/stories/';
		$pathtoplaceholder = 'components/com_docmanrss/assets/images/';
		$pathtoqrcode = 'tmp/';
		
		$channellink = JRoute::_ ( 'index.php?option=com_docmanrss&amp;view=dynfeed&amp;format=feed&amp;catid=' . $catid, true, - 1 );
		
		$feed = new UniversalFeedCreator ( );
		
		$feed->encoding = "UTF-8";
		$feed->link = $channellink;
		
		$feed->description = $params->get ( 'description', null );
		$feed->language = $params->get ( 'language', null );
		$feed->title = $params->get ( 'title', null );
		
		if (($params->get ( 'image_file', null ) != - 1) && ! ($params->get ( 'show_qrcode_feed', null ))) {
			$image = new FeedImage ( );
			
			$link = JURI::base () . 'images/M_images/' . $params->get ( 'image_file', 'con_info.png' );
			$image->url = $link;
			$image->link = $channellink;
			$image->title = $params->get ( 'title', null );
			$image->description = $params->get ( 'image_alt', null );
			$image->width = $params->get ( 'image_width', null );
			$image->height = $params->get ( 'image_height', null );
			
			$feed->image = $image;
		}
		elseif ($params->get ( 'show_qrcode_feed', null )) {
			
			$qrcodedata = $channellink;
			$imagetype = 'png';
			
			$filename = 'qrcode_' . $catid . '_dynfeed.' . $imagetype;
			
			$z = new Qrcode_image ( );
			
			//$z->set_qrcode_version(1);           # set qrcode version 1
			$z->set_qrcode_error_correct ( "l" ); # set ecc level H
			$z->set_module_size ( 4 ); # set module size 3pixel
			$z->set_quietzone ( 1 ); # set quietzone width 5 modules
			

			$z->qrcode_image_out ( $qrcodedata, $imagetype, JPath::clean ( JPATH_ROOT . DS . $pathtoqrcode . DS . $filename ) );
			
			$image = new FeedImage ( );
			
			$link = JURI::base () . $pathtoqrcode . $filename;
			$image->url = $link;
			$image->link = $channellink;
			
			$image->title = $params->get ( 'title', null );
			$image->description = $params->get ( 'image_alt', null );
			$image->width = $params->get ( 'image_width', null );
			$image->height = $params->get ( 'image_height', null );
			
			$feed->image = $image;
		
		}
		
		foreach ( $rows as $row ) {
			// strip html from feed item title
			$title = $this->escape ( $row->dmname );
			$title = html_entity_decode ( $title );
			
			//generates the link. doc_details or doc_downloads
			

			$link = JRoute::_ ( 'index.php?option=com_docman&amp;task=' . ($params->get ( 'link_target', 0 ) ? 'doc_details' : 'doc_download') . '&amp;gid=' . $row->item . '&Itemid=' . $itemid, true, - 1 );
			
			$linkenclosure = JRoute::_ ( 'index.php?option=com_docman&amp;task=doc_download&amp;gid=' . $row->item . '&Itemid=' . $itemid, true, - 1 );
			
			// show/hide category
			if ($params->get ( 'show_category', 0 )) {
				$category = DocmanrssHelper::getCategoryPath ( $categories, $row->catid );
				$category = $this->escape ( $category );
				$category = html_entity_decode ( $category );
			}
			
			// strip html from feed item description text
			$description = $this->escape ( $row->dmdescription );
			$description = html_entity_decode ( $description );
			$description = $params->get ( 'limit_text', null ) ? FeedCreator::iTrunc ( $description, $params->get ( 'text_length', null ) ) : $description;
			
			if (JFile::exists ( JPATH_ROOT . DS . $pathtothumb . $row->dmthumbnail )) {
				$thumbnail = $row->dmthumbnail;
				$path = $pathtothumb;
			}
			else {
				
				if ($params->get ( 'show_placeholder', null )) {
					$thumbnail = 'no_thumb.png';
					$path = $pathtoplaceholder;
				}
				else {
					$thumbnail = null;
				}
			}
			
			if ($params->get ( 'show_qrcode_feeditem', null )) {
				$qrcodedata = $link;
				
				$imagetype = 'png';
				$filename = 'qrcode_dyn_' . $catid . '_' . $row->item . '.' . $imagetype;
				
				$z = new Qrcode_image ( );
				
				//$z->set_qrcode_version(1);           # set qrcode version 1
				$z->set_qrcode_error_correct ( "l" ); # set ecc level H
				$z->set_module_size ( 4 ); # set module size 3pixel
				$z->set_quietzone ( 1 ); # set quietzone width 5 modules
				

				$z->qrcode_image_out ( $qrcodedata, $imagetype, JPath::clean ( JPATH_ROOT . DS . $pathtoqrcode . DS . $filename ) );
			}
			
			$description = '
			<table>
				<tr valign="top">
					' . (($params->get ( 'qrcode_feeditem_position', null ) == 0) ? ((($params->get ( 'show_qrcode_feeditem', null )) && (JFile::exists ( JPATH_ROOT . DS . $pathtoqrcode . DS . $filename ))) ? '<td>' . '<img src="' . JURI::base () . $pathtoqrcode . $filename . '"/>' . '</td>' : '') : '') . '
					' . ((($params->get ( 'show_thumb', null )) && ($thumbnail)) ? '<td>' . '<img src="' . JURI::base () . $path . $thumbnail . '"/>' . '</td>' : '') . '
					<td width="100%">
					' . $description . '
					</td>
					' . (($params->get ( 'qrcode_feeditem_position', null ) == 1) ? ((($params->get ( 'show_qrcode_feeditem', null )) && (JFile::exists ( JPATH_ROOT . DS . $pathtoqrcode . DS . $filename ))) ? '<td>' . '<img src="' . JURI::base () . $pathtoqrcode . $filename . '"/>' . '</td>' : '') : '') . '	
				</tr>
			</table>';
			
			if ($params->get ( 'show_enclosure', null )) {
				
				$enclosure = new EnclosureItem ( );
				
				$enclosure->url = $linkenclosure;
				$enclosure->length = @filesize ( JPath::clean ( $docmanconfig->dmpath . DS . $row->dmfilename ) );
				$enclosure->type = DocmanrssHelper::getMime ( JPath::clean ( $docmanconfig->dmpath . DS . $row->dmfilename ), $row->dmfilename );
			}
			
			// load individual item creator class
			$item = new FeedItem ( );
			
			$item->title = $title;
			$item->link = $link;
			
			$item->description = $description;
			
			//			$item->author		= $author; 		//TBD
			//			$item->authorEmail		= $authoremail;	//TBD
			$item->category = $category;
			//			$item->comments = $comments;	//TBD
			

			$item->enclosure = $enclosure;
			//			$item->guid = $link;	
			

			$item->date = ($params->get ( 'show_date', 0 )) ? $row->created_ts : null;
			$item->source = JURI::base ();
			
			// loads item info into rss array
			$feed->addItem ( $item );
		}
		
		$feed->saveFeed ( "RSS2.0", JPATH_CACHE . '/docrssdynfeed_' . $params->get ( 'filename', $catid ) . '.xml', true );
	
	}

	//Calculate Children created by Benjamin Trenkel www.benjamintrenkel.de
	function getChilds($id) {
		$model = $this->getModel ();
		$result = $model->loadChild ( $id );
		
		$count = count ( $result );
		if ($count > 0) {
			
			for($i = 0; $i < $count; $i ++) {
				$result [$i]->child = $this->getChilds ( $result [$i]->id );
			}
			return $result;
		}
		return array ();
	}
	
	function getCatidstoarray($catids){
		
		foreach ($catids as $catid){
			$result[]=$catid->id;
			
			if(! empty($catid->child)){
				$temp = $this->getCatidstoarray($catid->child);
				$temp2 = array_merge($result,$temp);
				$result = $temp2;
			}
			
		}
		return $result;
		
	}

}
